<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: init.php 4346 2006-03-06 16:43:19Z andrew@m3.net $
*/

/**
 * @package    Max
 * @author     Andrew Hill <andrew@m3.net>
 *
 * A file to set up the environment for the Max administration interface.
 */

require_once 'init-parse.php';
require_once 'constants.php';
require_once 'PEAR.php';

/**
 * The environment initialisation function for the Max administration interface.
 *
 * @TODO Should move the user authentication, loading of preferences into this
 *       file, and out of the /www/admin/config.php file.
 */
function init()
{
    // Disable all notices and warnings, as some PAN code still
    // generates PHP warnings in places
    error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
    // If not being called from the installation script...
    if (basename($_SERVER['PHP_SELF']) != 'install.php') {
        // Direct the user to the installation script if not installed
        if (!$GLOBALS['_MAX']['CONF']['max']['installed']) {
            $path = dirname($_SERVER['PHP_SELF']);
            if ($path == '/') {
                $path = '';
            }
            if ($GLOBALS['_MAX']['ROOT_INDEX']) {
                // The root index.php page was called to get here
                $location = 'Location: ' . $GLOBALS['_MAX']['HTTP'] .
                       $_SERVER['HTTP_HOST'] . $path . '/www/admin/' . 'install.php';
                header($location);
            } elseif ($GLOBALS['_MAX']['WWW_INDEX']) {
                // The index.php page in /www was called to get here
                $location = 'Location: ' . $GLOBALS['_MAX']['HTTP'] .
                       $_SERVER['HTTP_HOST'] . $path . '/admin/' . 'install.php';
                header($location);
            } else {
                // The index.php page in /www/admin was called to get here
                $location = 'Location: ' . $GLOBALS['_MAX']['HTTP'] .
                       $_SERVER['HTTP_HOST'] . $path . '/install.php';
                header($location);
            }
            exit();
        }
    }
    // Start PHP error handler
    $conf = $GLOBALS['_MAX']['CONF'];
    include_once MAX_PATH . '/lib/max/ErrorHandler.php';
    $eh = new MAX_ErrorHandler();
    $eh->startHandler();
}

// Run the init() function
init();

// Set $conf
$conf = $GLOBALS['_MAX']['CONF'];

?>
