<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: GeoIP.plg.test.php 4405 2006-03-10 10:25:58Z andrew@m3.net $
*/

require_once MAX_PATH . '/lib/max/Plugin.php';
require_once MAX_PATH . '/plugins/deliveryLimitations/Site/Referingpage.delivery.php';

/**
 * A class for testing the Plugins_DeliveryLimitations_Site_Referingpage class.
 *
 * @package    MaxPlugin
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@m3.net>
 */
class Plugins_TestOfPlugins_DeliveryLimitations_Site_Referingpage extends UnitTestCase
{

    /**
     * The constructor method.
     */
    function Plugins_TestOfPlugins_DeliveryLimitations_Site_Referingpage()
    {
        $this->UnitTestCase();
    }

    /**
     * A method to test the _getSqlLimitation() method.
     */
    function test_getSqlLimitation()
    {
        $oPlugin = &MAX_Plugin::factory('deliveryLimitations', 'Site', 'Referingpage');
        $result = $oPlugin->_getSqlLimitation('=~', 'Foobar');
        $this->assertEqual($result, "LOWER(referer) LIKE ('%foobar%')");
        $result = $oPlugin->_getSqlLimitation('!~', 'Bar"foo');
        $this->assertEqual($result, "LOWER(referer) NOT LIKE ('%bar\\\"foo%')");
    }
    
    function test_MAX_checkReferingPage()
    {
        $GLOBALS['referer'] = 'localhost';
        $this->assertTrue(MAX_checkSite_Referingpage('localhost', '=='));
        $GLOBALS['referer'] = 'localhos';
        $this->assertFalse(MAX_checkSite_Referingpage('localhost', '=='));

    }
}

?>
