<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id$
*/

require_once MAX_PATH . '/simulation/SimulationScenario.php';

/**
 * A class for simulating maintenance/delivery scenarios
 *
 * @package
 * @subpackage
 * @author
 */
class RunOfSite_nohistory extends SimulationScenario
{

    /**
     * The constructor method.
     */
    function RunOfSite_nohistory()
    {
        $this->init("max_v0.3.30-alpha_small_RunOfSite_nohistory_0001");
    }

    public function run()
    {
        $this->newTables();
        $this->loadDataset();

        $this->getPreSummary();

        for($i=1;$i<=$this->scenarioConfig['iterations'];$i++)
        {
            $this->makeRequests($i);
            $this->runPriority();
        }
        $this->getPostSummary();
    }

    /**
     * print out any post-run summary info you want
     *
     */
    function getPostSummary()
    {
        $this->printMessage('Simulation complete, printing summary...');
        $this->printMessage($msg);
        $msg =  '<h5>Total Delivery: '.$this->totalDelivery.'</h5>'
               .'<h5>Total Requests: '.$this->totalRequests.'</h5>'
               .'<h5>Total Percentage: '.(round(($this->totalDelivery/$this->totalRequests)*100,2)).'</h5>';
        $this->printMessage($msg);

        $query = "SELECT * FROM `data_summary_ad_zone_assoc`";
        $result = $this->oDBH->query($query);
        $this->printMessage('<h5>data_summary_ad_zone_assoc</h5>');
        while ($tmp = mysql_fetch_assoc($result->result))
        {
            $this->printMessage(print_r($tmp, true));
        }

        $query = "SELECT * FROM `data_summary_zone_impression_history`";
        $result = $this->oDBH->query($query);
        $this->printMessage('<h5>data_summary_zone_impression_history</h5>');
        while ($tmp = mysql_fetch_assoc($result->result))
        {
            $this->printMessage(print_r($tmp, true));
        }
    }

    /**
     * print out any pre-run summary info you want
     *
     */
    function getPreSummary()
    {
        $msg =  '<h1>Scenario Simulation: RunOfSite_nohistory</h1>'
                .'-- v0.3.30-alpha Run of Site Publisher<br />'
                .'-- zones=1<br />'
                .'-- banners=1<br />'
                .'-- required impressions=1000<br />'
                .'-- priority lvl=High(5)<br />'
                .'-- distribution=100(per day)<br />'
                .'-- [priority] instantUpdate was ON so priority was calced immediately at 0.8<br />'
                .'-- no impression history<br />';

        $this->printMessage($msg);
        $this->printMessage('data loaded, starting simulation...');
    }


}

?>
