<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id$
*/

//require_once MAX_PATH . '/tests/testClasses/TestFiles.php';

require_once 'init.php';

require_once 'HTML/TreeMenu.php';

/**
 * A class for managing the construction of groups of tests, and for
 * presenting them in an HTML menu.
 *
 * @package    Max
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@m3.net>
 */
class Menu
{

    /**
     * A method to return the HTML code needed to display a tree-based
     * menu of all the Max simulations.
     *
     * @return string A string containing the HTML code needed to display
     *                the tests in a tree-based menu.
     */
    function buildTree()
    {
        $icon_pkg = "package.png";

        // Create the root of the test suite
        $menu     = new HTML_TreeMenu();
        $rootNode = new HTML_TreeNode(
                            array(
                                'text' => 'Max Media Manager Simulation Scenarios',
                                'icon' => $icon_pkg
                            )
                        );
        // Create the top-level test groups
        $tmp = getcwd();
        $aTypes = array('DeliveryAndMaintenance');
        foreach ($aTypes as $type) {
            $nodeName = $type . 'RootNode';
            ${$nodeName} = new HTML_TreeNode(
                                array(
                                    'text' => ucwords($type),
                                    'icon' => $icon_pkg,
                                    'link' => "",
                                    'linkTarget' => "right"
                                )
                            );
            $files = getSimulationFilelist();
            foreach ($files as $index => $file) {
                if ($file <> '.' && $file <> '..' )
                {
                    $firstNode = &${$nodeName}->addItem(
                        new HTML_TreeNode(
                            array(
                                'text' => $file,
                                'icon' => $icon_pkg,
                                'link' => "run.php?dir=DeliveryAndMaintenance&file=$file",
                                'linkTarget' => 'right'
                                )
                        )
                    );
                }
            }
            $rootNode->addItem(${$nodeName});
        }
        // Add the root node to the menu, and return the HTML code
        $menu->addItem($rootNode);
        $tree = new HTML_TreeMenu_DHTML($menu);
        $code  = file_get_contents(MAX_PATH . '/tests/testClasses/menu.css');
        $code .= "\n<script>\n";
        $code .= file_get_contents(MAX_PATH . '/tests/testClasses/TreeMenu.js');
        $code .= "\n</script>";
        $code .= $tree->toHTML();
        return $code;
    }

}

function getSimulationFilelist()
{
    $aFiles = scandir('DeliveryAndMaintenance');
    return $aFiles;
}

// Output the menu of tests
echo Menu::buildTree();
?>
