<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-sessions.inc.php 5110 2006-07-10 15:06:09Z matteo@beccati.com $
*/

// Required files
require_once MAX_PATH . '/lib/max/other/lib-db.inc.php';
require_once MAX_PATH . '/lib/max/other/lib-io.inc.php';
require_once MAX_PATH . '/lib/max/Delivery/cookie.php';

/*-------------------------------------------------------*/
/* Fetch sessiondata from the database                   */
/*-------------------------------------------------------*/

function phpAds_SessionDataFetch()
{
	$conf = $GLOBALS['_MAX']['CONF'];
	global $session;
	if (isset($_COOKIE['sessionID']) && $_COOKIE['sessionID'] != '') {
        $query = "
            SELECT
                sessiondata
            FROM
                {$conf['table']['prefix']}{$conf['table']['session']}
            WHERE
                sessionid = '" . addslashes($_COOKIE['sessionID']) . "'
                AND UNIX_TIMESTAMP(NOW())-UNIX_TIMESTAMP(lastused) < 3600
            ";
		$result = phpAds_dbQuery($query);
		if ($row = phpAds_dbFetchArray($result)) {
			$session = unserialize($row['sessiondata']);
			// Reset LastUsed, prevent from timing out
            $query = "
                UPDATE
                    {$conf['table']['prefix']}{$conf['table']['session']}
                SET
                    lastused = NOW()
                WHERE
                    sessionid = '" . addslashes($_COOKIE['sessionID']) . "'
                ";
			phpAds_dbQuery($query);
		}
	} else {
		$_COOKIE['sessionID'] = '';
		return false;
	}
}

/*-------------------------------------------------------*/
/* Create a new sessionid                                */
/*-------------------------------------------------------*/

function phpAds_SessionStart()
{
	global $session;
	if (!isset($_COOKIE['sessionID']) || $_COOKIE['sessionID'] == '') {
		// Start a new session
		$session = array();
		$_COOKIE['sessionID'] = uniqid('phpads', 1);
		MAX_cookieSet('sessionID', $_COOKIE['sessionID']);
		MAX_cookieFlush();
	}
	return $_COOKIE['sessionID'];
}

/*-------------------------------------------------------*/
/* Register the data in the session array                */
/*-------------------------------------------------------*/

function phpAds_SessionDataRegister($key, $value='')
{
    $conf = $GLOBALS['_MAX']['CONF'];
	global $session;
	if ($conf['max']['installed']) {
		phpAds_SessionStart();
	}
	if (is_array($key) && $value=='') {
		foreach (array_keys($key) as $name) {
			$session[$name] = $key[$name];
		}
	} else {
		$session[$key] = $value;
	}
	phpAds_SessionDataStore();
}

/*-------------------------------------------------------*/
/* Store the session array in the database               */
/*-------------------------------------------------------*/

function phpAds_SessionDataStore()
{
    $conf = $GLOBALS['_MAX']['CONF'];
    global $session;
    if (isset($_COOKIE['sessionID']) && $_COOKIE['sessionID'] != '') {
        $query = "
            REPLACE INTO
                {$conf['table']['prefix']}{$conf['table']['session']}
            VALUES
                (
                    '" . addslashes($_COOKIE['sessionID']) . "',
                    '" . addslashes(serialize($session)) . "',
                    null
                )
            ";
        phpAds_dbQuery($query);
    }
    // Randomly purge old sessions
    srand((double)microtime()*1000000);
    if(rand(1, 100) == 42) {
        $query = "
            DELETE FROM
                {$conf['table']['prefix']}{$conf['table']['session']}
            WHERE
                UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP(lastused) > 43200
            ";
        phpAds_dbQuery($query);
    }
}

/*-------------------------------------------------------*/
/* Destroy the current session                           */
/*-------------------------------------------------------*/

function phpAds_SessionDataDestroy()
{
	$conf = $GLOBALS['_MAX']['CONF'];
	global $session;
	// Remove the session data from the database
	phpAds_dbQuery("
	   DELETE FROM
	       {$conf['table']['prefix']}{$conf['table']['session']}
	   WHERE
	       sessionid='" . addslashes($_COOKIE['sessionID']) . "'
	   ");
	// Kill the cookie containing the session ID
	MAX_cookieSet('sessionID', '');
	MAX_cookieFlush();	
	// Clear all local session data and the session ID
	$session = "";
	unset($session);
	$_COOKIE['sessionID'] = "";
	unset($_COOKIE['sessionID']);
}

?>
